﻿Imports System.Security.Cryptography
Imports System.Text.RegularExpressions

Module Module1

    Sub Main()
        '===========================================================================
        ' Subject: CALCULATING BIORHYTHMS             Date: Unknown Date (00:00:00)
        '  Author: Mark H. Butler                     Code: QB, PDS              
        '  Origin: CALCULATING,BIORHYTHMS           Packet: ALGOR.ABC
        '===========================================================================

        Const Digit$ = "1234567890"
        Const CenterLine$ = "1-2-3-4-5-6-7-8-9-0-"
        Const PI! = 3.1416
        Const Symbol23$ = "*"
        Const Symbol28$ = "#"
        Const Symbol33$ = "+"
        Dim NK$ = " "
        Dim Name$(10)
        Dim Month%(12), Month1$(12)
        Dim INN%

80:
        Month% = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}
        Month1$ = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"}

        Console.Clear()
        Console.ForegroundColor = ConsoleColor.Black
        Console.BackgroundColor = ConsoleColor.DarkCyan
        Console.SetCursorPosition(34, 2)
        Console.WriteLine(" BIORHYTHMS ")
        Console.ForegroundColor = ConsoleColor.Gray
        Console.BackgroundColor = ConsoleColor.Black
        Console.SetCursorPosition(0, 5)
        Console.WriteLine("The theory of biorhythms is that we are influenced by three rhythms, physical,")
        Console.WriteLine("emotional, and intellectual, beginning the day we are born.  The first and the")
        Console.WriteLine("middle days of each cycle are considered critical days. In the biorhythm chart")
        Console.WriteLine("which follows these days cross the dateline.")
        Console.WriteLine()
        'SOUND 2200, 1

560:
        Console.SetCursorPosition(0, 19)

        Console.Write("Please enter your name: ")
        Dim WHOM$ = Console.ReadLine

        If WHOM$ = "" Then
            Cuckoo()
            GoTo 560
        End If
        Dim NumberOfNames%
        IDParse(WHOM$, NumberOfNames%, Name$, 10)
        If NumberOfNames% > 1 Then
            WHOM$ = Name$(1) + " " + Name$(NumberOfNames%)
        Else
            WHOM$ = Name$(1)
        End If
600:

        Console.SetCursorPosition(0, 20)
        Console.Write(StrDup(78, " "))
        Console.SetCursorPosition(0, 20)

        Console.Write("What is " + WHOM$ + "'s " + "birthdate? MM-DD-YY ")
        Dim DateString2$ = Console.ReadLine
        On Error GoTo 2760
        If InStr(Digit$, Mid(DateString2$, 1, 1)) = 0 Then Error 0
        Dim N%
        If InStr(Digit$, Mid(DateString2$, 2, 1)) <> 0 Then N% = 2
        Dim BirthMonth% = Val(Mid(DateString2$, 1, N%))
        If BirthMonth% < 1 Or BirthMonth% > 12 Then Error 0

        Dim S% = N% + 2
        If InStr(Digit$, Mid(DateString2$, S%, 1)) = 0 Then Error 0
        N% = 1 : If InStr(Digit$, Mid(DateString2$, S% + 1, 1)) <> 0 Then N% = 2
        Dim BirthDate% = Val(Mid(DateString2$, S%, N%))
        If BirthDate% < 1 Or BirthDate% > 31 Then Error 0

        S% = S% + N% + 1
        Dim BirthYear% = Val(Mid(DateString2$, S%)) : If BirthYear% = 0 Then Error 0
        If BirthYear% < 100 Then BirthYear% = BirthYear% + 1900
        If BirthYear% < 1582 Then Error 0
        S% = N% + 2
        If InStr(Digit$, Mid(DateString2$, S%, 1)) = 0 Then Error 0
        N% = 1 : If InStr(Digit$, Mid(DateString2$, S% + 1, 1)) <> 0 Then N% = 2
        BirthDate% = Val(Mid(DateString2$, S%, N%))
        If BirthDate% < 1 Or BirthDate% > 31 Then Error 0
        S% = S% + N% + 1
        BirthYear% = Val(Mid(DateString2$, S%)) : If BirthYear% = 0 Then Error 0
        If BirthYear% < 100 Then BirthYear% = BirthYear% + 1900
        If BirthYear% < 1582 Then Error 0
980:
        Console.SetCursorPosition(0, 21)
        Console.WriteLine(StrDup(78, " "))
        Console.SetCursorPosition(0, 21)
        Console.Write("Start the biorhythm at : MM-YYYY ")
        DateString2$ = Console.ReadLine

        On Error GoTo 2780
        If InStr(Digit$, Mid(DateString2$, 1, 1)) = 0 Then Error 0
        N% = 1 : If InStr(Digit$, Mid(DateString2$, 2, 1)) <> 0 Then N% = 2
        Dim CalcMonth% = Val(Mid(DateString2$, 1, N%))
        If CalcMonth% < 1 Or CalcMonth% > 12 Then Error 0
        S% = N% + 2
        For i% = S% To Len(DateString2$)
            If InStr(Digit$, Mid(DateString2$, i%, 1)) = 0 Then Error 0
        Next
        Dim CalcYear% = Val(Mid(DateString2$, S%)) : If CalcYear% = 0 Then Error 0
        'IF CalcYear% < 100 THEN CalcYear% = CalcYear% + 1900
        If CalcYear% < 1582 Then Error 0
        If CalcYear% < BirthYear% Then Error 0
        If (CalcYear% = BirthYear%) And (CalcMonth% < BirthMonth%) Then Error 0
        On Error GoTo 0

        'DAYS FROM BIRTH TO END OF MONTH
        Dim TotalDays = Month%(BirthMonth% - 1) - BirthDate% + 1
        Dim Year = BirthYear%
        If Year Mod 4 <> 0 Then GoTo a1   'LEAP YEAR CALCULATION
        If (Year Mod 100 = 0) And (Year Mod 400 <> 0) Then GoTo a1
        Year = 0
a1:
        If BirthMonth% <= 2 And Year = 0 Then TotalDays = TotalDays + 1
        'LEAP YEAR ^
        For i% = (BirthMonth% + 1) To 12        'REST OF BIRTH YEAR

            TotalDays = TotalDays + Month%(i% - 1)
        Next i%
        Year = CalcYear% - BirthYear% - 1       'YEARS IN BETWEEN
        Dim C23% = 20 * Year
        Dim C28% = 1 * Year
        Dim C33% = 2 * Year

        For i% = (BirthYear% + 1) To (CalcYear% - 1)  'LEAP YEARS IN BETWEEN
            Year = i%
            If Year Mod 4 <> 0 Then GoTo a2   'LEAP YEAR CALCULATION
            If (Year Mod 100 = 0) And (Year Mod 400 <> 0) Then GoTo a2
            Year = 0
a2:
            If Year = 0 Then TotalDays = TotalDays + 1
        Next i%

        For i% = 1 To (CalcMonth% - 1)        'MONTHS
            TotalDays = TotalDays + Month%(i% - 1)
        Next i%

        Year = CalcYear%
        If Year Mod 4 <> 0 Then GoTo a3   'LEAP YEAR CALCULATION
        If (Year Mod 100 = 0) And (Year Mod 400 <> 0) Then GoTo a3
        Year = 0
a3:
        If CalcMonth% >= 2 And Year = 0 Then TotalDays = TotalDays + 1 'LEAP YEAR

        C23% = (C23% + TotalDays) Mod 23      'CALCULATE DAYS INTO CYCLE
        C28% = (C28% + TotalDays) Mod 28
        C33% = (C33% + TotalDays) Mod 33

        Console.ForegroundColor = ConsoleColor.Black
        Console.BackgroundColor = ConsoleColor.DarkBlue
        Console.Clear()
        Console.ForegroundColor = ConsoleColor.Black
        Console.BackgroundColor = ConsoleColor.DarkCyan
        Console.Write(Space(80))
        Console.SetCursorPosition(0, 0)
        Console.Write(" " + WHOM$ + "'s Biorhythm for " + Month1$(CalcMonth% - 1) + CalcYear%.ToString)
        Dim Birthdayline$ = "Birthdate is " + Month1$(BirthMonth% - 1) + Str(BirthDate%) + Str(BirthYear%)
        Console.CursorLeft = 79 - Len(Birthdayline$)
        Console.Write(Birthdayline$)
        Console.SetCursorPosition(0, 24)
        Console.ForegroundColor = ConsoleColor.Black
        Console.BackgroundColor = ConsoleColor.DarkGreen
        Console.Write(" " + Symbol23$ + " PHYSICAL  ")
        Console.ForegroundColor = ConsoleColor.Black
        Console.BackgroundColor = ConsoleColor.Red
        Console.Write(" " + Symbol28$ + " EMOTIONAL  ")
        Console.ForegroundColor = ConsoleColor.Black
        Console.BackgroundColor = ConsoleColor.DarkMagenta
        Console.Write(" " + Symbol33$ + " INTELLECTUAL  ")
        Console.ForegroundColor = ConsoleColor.Black
        Console.BackgroundColor = ConsoleColor.DarkCyan
        Console.Write(Space(7) + "More BIORHYTHMS? Y/N ")
        Console.ForegroundColor = ConsoleColor.White
        Console.Write("Y" + Space(7))
        Console.SetCursorPosition(8, 12)
        Console.ForegroundColor = ConsoleColor.Black
        Console.BackgroundColor = ConsoleColor.DarkCyan
        Console.Write(CenterLine$ + CenterLine$ + CenterLine$ + "1")
        Dim J% = Month%(CalcMonth% - 1)
        Year = CalcYear%
        If Year Mod 4 <> 0 Then GoTo a4   'LEAP YEAR CALCULATION
        If (Year Mod 100 = 0) And (Year Mod 400 <> 0) Then GoTo a4
        Year = 0
a4:
        If CalcMonth% = 2 And Year = 0 Then J% = J% + 1
        Dim K% = 1
        Dim C% = 9
2200:
        Dim P23 = Math.Sin(2.0! * PI! * CSng(C23%) / 23.0!)
        Dim P28 = Math.Sin(2.0! * PI! * CSng(C28%) / 28.0!)
        Dim P33 = Math.Sin(2.0! * PI! * CSng(C33%) / 33.0!)
        Dim PNN = P23
        REM ROUTINE TO COMPUTE ROW NUMBER
        REM
        Dim PSGN = Math.Sign(PNN)
        Dim PTT = PSGN * 0.05
        If PTT = 0 Then PTT = 0.05
        Dim PQQ = -(PNN + PTT) / 0.1
        INN% = Fix(PQQ) + 13
        'SOUND 900, .05
        'SOUND 37, .05
        Threading.Thread.Sleep(100)
        Console.SetCursorPosition(C% - 1, INN% - 1)
        Console.ForegroundColor = ConsoleColor.Black
        Console.BackgroundColor = ConsoleColor.DarkGreen
        Console.Write(Symbol23$)
        PNN = P28
        REM ROUTINE TO COMPUTE ROW NUMBER
        REM
        PSGN = Math.Sign(PNN)
        PTT = PSGN * 0.05
        If PTT = 0 Then PTT = 0.05
        PQQ = -(PNN + PTT) / 0.1
        INN% = Fix(PQQ) + 13
        'SOUND 900, .05
        'SOUND 37, .05
        Threading.Thread.Sleep(100)
        Console.SetCursorPosition(C% - 1, INN% - 1)
        Console.ForegroundColor = ConsoleColor.Black
        Console.BackgroundColor = ConsoleColor.Red
        Console.Write(Symbol28$)
        PNN = P33
        REM ROUTINE TO COMPUTE ROW NUMBER
        REM
        PSGN = Math.Sign(PNN)
        PTT = PSGN * 0.05
        If PTT = 0 Then PTT = 0.05
        PQQ = -(PNN + PTT) / 0.1
        INN% = Fix(PQQ) + 13
        'SOUND 900, .05
        'SOUND 37, .05
        Threading.Thread.Sleep(100)
        Console.SetCursorPosition(C% - 1, INN% - 1)
        Console.ForegroundColor = ConsoleColor.Black
        Console.BackgroundColor = ConsoleColor.DarkMagenta
        Console.Write(Symbol33$)
        K% = K% + 1
        C% = C% + 2
        C23% = C23% + 1            'next day

        C28% = C28% + 1
        C33% = C33% + 1
        If K% <= J% Then GoTo 2200
        Console.ForegroundColor = ConsoleColor.Gray
        Console.BackgroundColor = ConsoleColor.Black
2540:
        Console.SetCursorPosition(70, 24)
        DateString2$ = Console.ReadLine
        DateString2$ = UCase(DateString2$)
        If DateString2$ = Chr(13) Or DateString2$ = "Y" Then
            GoTo 80
        ElseIf DateString2$ = "N" Then
            Lineout()
            End
        Else
            Cuckoo()
        End If
        GoTo 2540
2580:
        REM ROUTINE TO COMPUTE ROW NUMBER
        REM
        PSGN = Math.Sign(PNN)
        PTT = PSGN * 0.05
        If PTT = 0 Then PTT = 0.05
        PQQ = -(PNN + PTT) / 0.1
        INN% = Fix(PQQ) + 13
        'SOUND 900, .05
        'SOUND 37, .05
        Threading.Thread.Sleep(100)
        Return

2760:
        Console.WriteLine(DateString2$ + " is an invalid date, please reenter" + StrDup(20, " "))
        Cuckoo()
        Resume 600
2780:
        Console.WriteLine(DateString2$ + " is an invalid date, please reenter" + StrDup(20, " "))
        Cuckoo()
        Resume 980

PrintError:
        Console.Clear()
        Console.WriteLine("Printer access error.")
        End
    End Sub

    Sub Cuckoo()
        'SOUND 750, 1
        'SOUND 550, 1
    End Sub

    Sub IDParse(IDLine$, ByRef NumberOfNames%, ByRef Name$(), MaxNames%)
        NumberOfNames% = 0 : Dim In% = False
        Dim Cl$ = IDLine$
        Dim L = Len(Cl$)
        For i% = 1 To L
            Dim C$ = Mid(Cl$, i%, 1)
            If (C$ <> " " And C$ <> Chr(9) And C$ <> "/") Then
                If Not In% Then
                    If NumberOfNames% = MaxNames% Then Exit For
                    NumberOfNames% = NumberOfNames% + 1
                    In% = True
                End If
                Name$(NumberOfNames%) = Name$(NumberOfNames%) + C$
            Else
                In% = False
            End If
        Next i%
        For i% = 1 To NumberOfNames%
            Dim IDLen% = Len(Name$(i%))
            Dim Big$ = UCase(Left(Name$(i%), 1))
            Dim Little$ = LCase(Mid(Name$(i%), 2, IDLen%))
            Name$(i%) = Big$ + Little$
        Next i%
    End Sub

    Sub Lineout()
        Dim Lines$(24)

        Lines$(1) = StrDup(80, Chr(196))
        Dim Sp% = 2
        Dim Ln% = 76
        For i% = 2 To 21
            Lines$(i%) = Space(Sp%) + StrDup(Ln%, Chr(196)) + Space(2)
            Sp% = Sp% + 2
            Ln% = Ln% - 4
        Next i%

        Lines$(22) = Space(39) + Chr(254) + Space(2)
        Lines$(23) = Space(39) + Chr(249) + Space(2)

        Console.ForegroundColor = ConsoleColor.Black
        Console.BackgroundColor = ConsoleColor.Black
        Dim X% = 1
        Dim y% = 25
        For i% = 1 To 12
            Console.SetCursorPosition(0, y% - 1)
            Console.Write(StrDup(80, Chr(32)))
            Console.SetCursorPosition(0, X% - 1)
            Console.WriteLine(StrDup(80, Chr(32)))
            Threading.Thread.Sleep(100)
            X% = X% + 1
            y% = y% - 1
        Next i%
        Console.ForegroundColor = ConsoleColor.DarkCyan
        Console.BackgroundColor = ConsoleColor.Black
        For i% = 1 To 23
            Console.SetCursorPosition(0, 12)
            Console.Write(Lines$(i%))
            Threading.Thread.Sleep(100)
        Next i%
        Console.ForegroundColor = ConsoleColor.Gray
        Console.BackgroundColor = ConsoleColor.Black
        Console.Clear()
    End Sub

End Module
